------------------------------------------------------------------------------
--	NbN̓eXg
--	created by t.hara
------------------------------------------------------------------------------
library	ieee;
	use	ieee.std_logic_1164.all;
	use	ieee.std_logic_unsigned.all;

entity tb is
end tb;

architecture bhv of tb is
	component clock_div
		port(
			reset		: in	std_logic;
			clk21m		: in	std_logic;
			o_cpuclk	: out	std_logic;
			o_clkena	: out	std_logic;
			o_clkdiv	: out	std_logic_vector(1 downto 0)
		);
	end component;

	component org_clock_div
		port(
			clk21m		: in	std_logic;
			o_cpuclk	: out	std_logic;
			o_clkena	: out	std_logic;
			o_clkdiv	: out	std_logic_vector(1 downto 0)
		);
	end component;

	signal reset		: std_logic := '1';
	signal clk21m		: std_logic := '0';

	signal cpuclk		: std_logic;
	signal org_cpuclk	: std_logic;
	signal clkena		: std_logic;
	signal org_clkena	: std_logic;
	signal clkdiv		: std_logic_vector(1 downto 0);
	signal org_clkdiv	: std_logic_vector(1 downto 0);

	signal tb_end		: std_logic := '0';

	constant clock		: time := 10 ns;
begin

	-- clock generator
	process
	begin
		if( tb_end = '1' )then
			wait;
		end if;
		if( reset = '1' )then
			wait for clock;
		else
			clk21m <= '1';
			wait for clock / 2;
			clk21m <= '0';
			wait for clock / 2;
		end if;
	end process;

	-- connect
	target: clock_div
	port map(
		reset		=> reset,
		clk21m		=> clk21m,
		o_cpuclk	=> cpuclk,
		o_clkena	=> clkena,
		o_clkdiv	=> clkdiv
	);

	reference: org_clock_div
	port map(
		clk21m		=> clk21m,
		o_cpuclk	=> org_cpuclk,
		o_clkena	=> org_clkena,
		o_clkdiv	=> org_clkdiv
	);

	-- test bench
	process
	begin
		reset <= '1';
		wait for clock;
		reset <= '0';
		wait for clock * 20;
		tb_end	<= '1';
		wait;
	end process;
end bhv;
